• Do not register here on develop.twiki.org, login with your twiki.org account.
• Use View topic Item7848 for generic doc work for TWiki-6.1.1. Use View topic Item7851 for doc work on extensions that are not part of a release. More... Close
• Anything you create or change in standard webs (Main, TWiki, Sandbox etc) will be automatically reverted on every SVN update.
Does this site look broken?. Use the LitterTray web for test cases.

Item7874: CgiContrib to have CGI version 4.44

Item Form Data

AppliesTo: Component: Priority: CurrentState: WaitingFor: TargetRelease ReleasedIn
Extension   Normal New   patch  

Edit Form Data

Summary:
Reported By:
Codebase:
Applies To:
Component:
Priority:
Current State:
Waiting For:
Target Release:
Released In:
 

Detail

CgiContrib has CGI version 4.13, which is updated.

-- TWiki:Main/HideyoImazu - 2019-12-05

Note that this will create warnings - and probably die if $cfg{WarningsAreErrors} is set in a developer installation.

Back then, the CGI distribution was intentionally frozen at version 4.13 because the maintainer, Lee Johnson, had announced incompatible changes: TWiki:Codev/AddCGIpmToTWikiCore has the details. However, as of 2019 most of the "old stuff" still works without a warning - with one notable exception: TWiki does use CGI qw( :any ); in a few places, which is no longer supported and gives a warning CGI -any pragma has been REMOVED. You should audit your code for any use of none supported / incorrectly spelled tags and remove them.

The places are:

  • core/bin/configure
  • core/lib/TWiki/Configure/Type.pm
  • BuildContrib/lib/TWiki/Contrib/Build.pm
  • PSGIEngineContrib/lib/TWiki/Contrib/PSGIEngineContrib/Configure.pm
  • TestFixturePlugin/lib/TWiki/Plugins/TestFixturePlugin.pm

As far as I can say after a first examination, TWiki does not abuse the :any featuren in any of these places. The HTML generation function of CGI.pm is still in place. Therefore it should be safe to simply remove the qw( :any ) parameter from these five places (but a bit of testing won't hurt).

If this actually does work, then CgiContrib might be retired from newer TWiki versions: CGI.pm is available from CPAN and from all known package managers, so it could just be added to TWiki's CPAN requirements.

-- TWiki:Main.HaraldJoerg - 2019-12-05

Sorry for my ignorance about the reason why CgiContrib was sticking to 4.13. There is one problem with 4.13 at CGI/Carp.pm

if ($ENV{HTTP_USER_AGENT} =~ /MSIE/) {

causes a warning under some situations. 4.44 has it corrected to

if (defined($ENV{HTTP_USER_AGENT}) && $ENV{HTTP_USER_AGENT} =~ /MSIE/) {

But this doesn't justify the update. I've just reverted the changes I made for this item from the repository. Both with the trunk and the TWikiRelease06x01 branch.

-- TWiki:Main.HideyoImazu - 2019-12-06

ItemTemplate
Summary CgiContrib to have CGI version 4.44
ReportedBy TWiki:Main.HideyoImazu
Codebase

SVN Range TWiki-6.0.2-trunk, Sat, 07 Jul 2018, build 30509
AppliesTo Extension
Component

Priority Normal
CurrentState New
WaitingFor

Checkins TWikirev:30681 TWikirev:30682 TWikirev:30683 TWikirev:30684 TWikirev:30685
TargetRelease patch
ReleasedIn

Edit | Attach | Watch | Print version | History: r6 < r5 < r4 < r3 < r2 | Backlinks | Raw View | Raw edit | More topic actions
Topic revision: r6 - 2019-12-06 - HideyoImazu
 
This site is powered by the TWiki collaboration platform Powered by PerlCopyright © 2008-2020 by the contributing authors. All material on this collaboration platform is the property of the contributing authors.
Ideas, requests, problems regarding TWiki? Send feedback